# PyTorch README

## Usage

Currently, we only implemented the IR -> PyTorch part.

I am implementing the PyTorch parser in branch [pytorch](https://github.com/Microsoft/MMdnn/tree/pytorch) and have some issue with getting layer shape and jit CppOP. Waiting for JIT completion.

Any contribution to PyTorch parser (PyTorch -> IR) is welcome.

### Extract PyTorch pre-trained models

You can refer [PyTorch model extractor](https://github.com/Microsoft/MMdnn/blob/master/mmdnn/conversion/examples/pytorch/extract_model.py) to extract your pytorch models.

```bash
$ python -m mmdnn.conversion.examples.pytorch.extract_model -h
usage: extract_model.py [-h] -n
                        {densenet,squeezenet,vgg16,resnet152,vgg19,inception_v3}
```

### Convert models from IR to PyTorch code snippet and weights

We need to transform the IR weights to PyTorch suitable weights. Use argument *-dw* to specify the output weight file name.

```bash
$ python -m mmdnn.conversion._script.IRToCode --dstModelFormat pytorch --IRModelPath inception_v3.pb --IRWeightPath inception_v3.npy --dstModelPath pytorch_inception_v3.py -dw pytorch_inception_v3.npy

Parse file [kit_imagenet.pb] with binary format successfully.
Target network code snippet is saved as [pytorch_inception_v3.py].
Target weights are saved as [pytorch_inception_v3.npy].
```

### Convert models from IR to PyTorch original model

After generating the PyTorch code snippet, you can convert the code and weights file to PyTorch original model for further usage.

```bash
$ python -m mmdnn.conversion.examples.pytorch.imagenet_test -n pytorch_inception_v3.py -w pytorch_inception_v3.npy --dump pytorch_inception_v3.pth

PyTorch model file is saved as [pytorch_inception_v3.pth], generated by [pytorch_inception_v3.py] and [pytorch_inception_v3.npy].
```

## Example

Detail scripts of *Tensorflow slim resnet_v1_101 model* to *PyTorch* conversion are in [issue 22](https://github.com/Microsoft/MMdnn/issues/22). You can refer it to implement your conversion.

## Develop version

Ubuntu 16.04 with

- PyTorch 0.4.0a0+7ddcb91

@ 2017/12/06

## Limitation

- The main dataflow in a pytorch network is converted from NHWC(channel last) to NCHW(channel first) format, but some operators (like Concat) with axis may not transform correctly. You may need to correct it manually.

- Currently, no RNN-related operations supported
